
#define BLOCKSIZE 512


struct adostime
{
    unsigned long days, mins, ticks;
};
#define TICKS_PER_SECOND	50	/* Number of ticks in one second */
#define TIME_OFFSET	252460800 /* ADOS times are relative to this (1978) */


#define T_SHORT 2
#define T_LIST ?
#define T_DATA ?
#define ST_ROOT 1
#define ST_USERDIR 2
#define ST_FILE -3



struct filsys
{
    unsigned long type;
    unsigned long key;
    unsigned long seq;
    unsigned long htsize;
    unsigned long pad0;
    unsigned long checksum;
    unsigned long hashtable[72];
    unsigned long bmflag;
    unsigned long bmblocks[26];
    struct adostime mtime;
    char namelen;
    char name[51];
    struct adostime ctime;
    unsigned long pad1;
    unsigned long pad2;
    unsigned long pad3;
    long stype;
};


#define NADDR 72

struct dinode
{
    unsigned long type;
    unsigned long key;
    unsigned long seq;
    unsigned long nblocks;
    unsigned long firstblock;
    unsigned long checksum;
    unsigned long addr[NADDR];
    unsigned long pad0;
    unsigned long pad1;
    unsigned long protect;
    unsigned long size;
    char commentlen;
    char comment[91];
    struct adostime mtime;
    char namelen;
    char name[63];
    unsigned long hashchain;
    unsigned long parent;
    unsigned long indir;
    long stype;
};


struct indirblock
{
    unsigned long type;
    unsigned long key;
    unsigned long nblocks2;
    unsigned long nblocks;
    unsigned long firstblock;
    unsigned long checksum;
    unsigned long addr[NADDR];
    unsigned long pad0[46];
    unsigned long pad1;
    unsigned long parent;
    unsigned long next;
    long stype;
};


struct datablock
{
    unsigned long type;
    unsigned long key;
    unsigned long seq;
    unsigned long size;
    unsigned long next;
    unsigned long checksum;
    unsigned char data[488];
};
